# -*- coding: iso-8859-15 -*-

###################
# TP 7 : Dijkstra #
###################

class Matrice:
    # Cre une matrice de taille nxn dont tous les coefficient vallent d
    def __init__(self,n,d=0):
        self.n=n
        self.coeffs=[]
        for l in range(n):
            self.coeffs.append([d]*n)

    # Permet d'afficher la matrice avec print
    def __repr__(self):
        str=""
        for l in range(self.n):
            for c in range(self.n):
                str=str+repr(self.coeffs[l][c])+'\t'
            str=str+'\n'
        return str

    # Retourne la valeur du coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def lire(self,l,c):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        return self.coeffs[l-1][c-1]

    # Affecte une valeur au coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def ecrire(self,l,c,v):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        self.coeffs[l-1][c-1]=v

# Nous allons reprsent les
#  - graphes non orient
#  - graphes orient
# grce a leurs matrices d'ajacences.
# Ainsi lorsqu'on parlera du graph G, on supposera que G a la martice d'adjacence du grpahe G

#------------
# Exercice 1
#------------

# 1. Ecrire une fonction ajoute_arete(G,i,j,e) qui ajoute une arete i -- j avec l'etiquette e dans le graphe orient G

def ajoute_arete(G,i,j,e):
    G.ecrire(i,j,e)

# 2. Ecrire une fonction ajoute_plusieurs_aretes (G,l) qui tant donne une liste de couple (i,j,e
#    ajoute l'arete i -> j  G tiquetee e. Exemple : ajoulte_plusieurs_aretes(G,[(1,2,10),(4,3,7)])

def ajoute_plusieurs_aretes(G,l):
    for (i,j,e) in l:
        ajoute_arete(G,i,j,e)

# 3. Crer le graphe oriente de l'exercice 2 du TD 5

G=Matrice(6)
ajoute_plusieurs_aretes(G,[(1,2,3),(1,3,5),(1,6,1),(2,3,2),(3,4,5),(3,5,2),(3,6,1),(5,4,2),(5,3,3),(6,2,1),(6,4,15),(6,5,6)])

#------------
# Exercice 2
#------------

# 1. Ecrire une fonction dijkstra(G,s,e) qui tant donn un graphe G etiquete caclul  l'aide
#    de l'algorithm de Dijkstra-Moore le plus court chemin entre les sommets s et e.

def dijkstra(G,s,e):
    n=G.n
    visite=[False]*(n+1) # visite[i] specifie si i a ete visite
    cout=[(None,None)]*(n+1)
    # cout[i]=(c,v) on a pour le moment que le cout pour aller de s a i est de c
    # en passant par l'arete v -- i
    cout[s]=(0,None)
    while True:
        # Rechercher le sommet non visite m de cout minimal cm
        m=None
        cm=None
        for i in range(1,n+1):
            if not visite[i]:
                (c,v)=cout[i]
                if c!=None and m==None:
                    m=i
                    cm=c
                else:
                    if c!=None and c<cm:
                        m=i
                        cm=c
        if m==e:
            print("Le cout minimal pour aller de",s,"",e,"est",cm)
            print("Un tel cout est realise par le chemin : ")
            chemin=repr(e)
            (c,v)=cout[m]
            while v!=None:
                chemin=" -> "+chemin
                chemin=repr(v)+chemin
                (c,v)=cout[v]
            print(chemin)
            return
        
        print("Le sommet de plus petit cout non visite est",m,"et a un cout de",cm)
        for v in range(1,n+1):
            c=G.lire(m,v)
            if not visite[v] and c>0:
                cv=cout[v][0] # Le cout courant pour aller de s a v
                if cv==None or cm+c<cv:
                    cout[v]=(cm+c,m)
        visite[m]=True
        print(cout[1:])
                
                    
        
    
# 2. Tester votre algorithme sur le graphe cr  l'exercice prcdent.

if __name__=="__main__":
    print(G)
    dijkstra(G,1,4)
